# Compiling LaTeX documents: beamer slides

This example compiles a LaTeX document containing some beamer slides
on a shared runner. The generated PDF is available as
[artifact](https://gitlab.inria.fr/gitlabci_gallery/latex/latex-beamer/-/jobs/artifacts/main/raw/slides.pdf?job=build).

There are several benefits for compiling the LaTeX document via
continuous integration instead of storing the `.pdf` file
in the repository:

- the `.pdf` file is a generated binary, causing spurious conflicts
  each time several authors edited the `.tex` file concurrently;

- the local compilation may depend upon the LaTeX environment
  installed on one of the author's particular machine, whereas
  continuous integration ensures that the compilation environment
  is commonly specified;

- authors can contribute even if they don't have easily access to a
  machine with LaTeX, for instance if they are remote, on their
  phone or tablet, etc.

## Prerequisites

This project requires the following common prerequisites.
See the [intro](https://gitlab.inria.fr/gitlabci_gallery/intro) project for
details.

- Enable project CI/CD feature
- Enable shared runners
- Enable container registry

## The LaTeX document [`slides.tex`](slides.tex)

The LaTeX document [`slides.tex`](slides.tex) uses the `fontspec`
package, which requires to be compiled with `lualatex` (or `xelatex`,
[which seems to be unmaintainted](https://tex.stackexchange.com/questions/593031/what-are-the-downsides-of-using-xetex#answer-593217)):
the `luatex` engine supports UTF-8 documents out-of-the-box and modern
typography.

Other packages are `hyperref` for working hyperlinks, `minted` for
code coloration and `biblatex` for the bibliography.
The `minted` package requires `latex` to be run with
the option `-shell-escape` and relies on the Python tool
`pygmentize`.

At the end of the file, there are some comment variables that are
defined for Emacs users so that correct engine and options are used
when Emacs recompiles the file.

A `Makefile` is provided, that uses `latexmk` to recompile
automatically the document and the bibliography the required number of
times for all references to be up-to-date.

The pipeline is written such that the same `Makefile` is used by the
continuous integration.

## The environment specification [`Dockerfile`](Dockerfile)

The compilation environment is specified in [`Dockerfile`](Dockerfile)
so that to be reproducible and cached in the container registry,
not to have to reinstall the tools at every commit but only when
the environment is changed.

The package `make` is installed together with
`texlive-full`, so that the `Makefile` can be used to compile the
document within the container.

The package `py3-pygments` provides the `pygmentize` tool
required by `minted`: if you don't plan to use `minted` syntactic
coloration, you may remove this package.

The package `biber` provides `biblatex.sty` and the `biber` back-end,
for bibliography management: if you don't plan to use `biblatex` for
generating the bibliography, you may remove this package.

## The pipeline specification [`.gitlab-ci.yml`](.gitlab-ci.yml)

The pipeline uses
[`register-dockerfile.yml`](https://gitlab.inria.fr/inria-ci/docker/-/tree/main/register-dockerfile)
template to prepare a Docker image
with the environment specified in [`Dockerfile`](Dockerfile).

In addition to the jobs `prepare` and `clean`,
associated to the template above,
the pipeline defines the following job which uses the container
prepared by the template,
runs `make` in the repository, and then uploads `slides.pdf` as
artifact.

```yaml
build:
  tags:
    - linux
    - small
  image: "$image"
  script:
    - make
  artifacts:
    paths:
      - slides.pdf
```

## Ignored files in [`.gitignore`](.gitignore)

[`.gitignore`](.gitignore) instructs git to ignore the local files
generated by the `latexmk` command, in the case this command is used
for compiling the document locally.
